<template>
  <v-card class="pt-4">
    <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-smartphone' : 'dialog-content-scrollerd'">
      <v-form ref="form" @submit.prevent="validarFormulario">
        <v-text-field
          v-model="formCliente.nombre"
          label="Nombre"
          type="text"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-text-field
          v-model="formCliente.dni"
          label="DNI"
          type="text"
          :rules="rules.dni"
          required
          color="accent"
        />
        <v-text-field
          v-model="formCliente.telefono"
          label="Teléfono"
          type="text"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-text-field
          v-model="formCliente.direccion"
          label="Dirección"
          type="text"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-text-field
          v-model="formCliente.email"
          label="E-mail"
          type="text"
          :rules="rules.email"
          required
          color="accent"
        />
      </v-form>
    </v-card-text>

    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn v-if="!isEditar" class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Agregar
      </v-btn>
      <v-btn v-else class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Modificar
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { Cliente } from '~/core/models/cliente'
import { ClientesStore } from '~/store/ClientesStore'

    @Component
export default class formClientes extends Vue {
        @Ref('form') formulario;

        @Prop({ default: null }) cliente!:Cliente;
        @Prop({ default: false }) formDesdeVentas!:boolean;

        menufecha:boolean = false;

        formCliente:Cliente = {
          direccion: '',
          nombre: '',
          dni: null,
          telefono: null,
          email: ''
        };

        rules = {
          nombre: [
            v => !!v || 'Campo requerido'
          ],
          dni: [
            v => !!v || 'Campo requerido',
            v => /^[0-9]*$/.test(v) || 'Solo debe ingresar números',
            v => /^[0-9]{5,15}$/.test(v) || 'El número no alcanza el mínimo de dígitos o supera el máximo de dígitos'
          ],
          email: [
            v => !!v || 'Campo requerido',
            v => /.+@.+/.test(v) || 'E-mail inválido'
          ]
        };

        get isEditar () {
          return this.cliente
        }

        mounted () {
          if (this.isEditar) {
            this.cargarForm()
          }
        }

        private cargarForm () {
          Object.assign(
            this.formCliente,
            this.cliente
          )
        }

        cerrarDialog () {
          this.$emit('onClose')
        }

        validarFormulario () {
          if (this.formulario.validate()) {
            if (this.isEditar) {
              this.modificar()
            } else {
              this.guardar()
            }
          } else {
            AppToast.error('Campos inválidos')
          }
        }

        private async guardar () {
          AppStore.SHOW_LOADING('Guardando Cliente')

          try {
            await ClientesStore.registrarClientes(this.formCliente).then((response) => { this.$emit('addedCliente', response) })
            this.cerrarDialog()
            AppToast.success('Cliente registrado')
          } catch (e) {
          }
          AppStore.HIDE_LOADING()
        }

        private async modificar () {
          AppStore.SHOW_LOADING('Guardando Cliente')
          try {
            await ClientesStore.modificarCliente(this.formCliente)
            this.cerrarDialog()
            AppToast.success('Cliente registrado')
          } catch (e) {
          }
          AppStore.HIDE_LOADING()
        }
}
</script>

<style lang="scss">

</style>
